from yos.yql import db

class BossResultList(object):
    """
    A wrapper around the response from a query to the Yahoo BOSS
    Framework.

    >>> from yos.boss import ysearch
    >>> data = ysearch.search("BOSS")
    >>> lst = BOSSResultsList(data)

    """
    def __init__(self, response):
        self.data = response
        details = self.data['ysearchresponse']
        self.__start = int(details['start'])
        self.__count = int(details['count'])
        self.__totalhits = int(details['totalhits'])
        self.__results = db.create(data=self.data).rows

    def __getitem__(self,i):
        return self.__results[i - self.__start]

    def __getslice__(self, i, j):
        return self.__results[i-self.__start:j-self.__start]

    def __len__(self):         
        return self.__totalhits

