from django.shortcuts import render_to_response
from django import newforms as forms
from yos.boss import ysearch
from yos.yql import db
from django.core.paginator import Paginator
from boss_utils import BossResultList

def search(str, type, count=10, start=0):
    return ysearch.search(str,vertical=type,start=start,count=count)


SEARCH_TYPES = (('web','Web'),('news','News'),('images','Images'))

class SearchForm(forms.Form):
    search_terms = forms.CharField(max_length=200)
    search_type = forms.ChoiceField(SEARCH_TYPES)


def index(request,count=10):
    results,page,total_pages,terms,type = None,None,None,None,None
    if request.method == "GET":
        form = SearchForm(request.GET)
        if form.is_valid():
            page = (request.GET.has_key('page') and int(request.GET['page'])) or 1
            start = (page-1) * count
            terms = request.GET['search_terms']
            type = request.GET['search_type']
            brl = BossResultList(search(terms,type,count=count,start=start))
            paginator = Paginator(brl,count)
            total_pages = len(brl) / count
            results = paginator.page(page)
        else:
            form = SearchForm()
    return render_to_response('yahoo_search/index.html',
                              {'form': form,'results': results,
                               'term': terms,'type': type,
                               'current_page': page,
                               'total_pages': total_pages})
